Unit LOpt;
Interface
Uses
    SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
    Forms, Dialogs, TabNotBk, StdCtrls, Buttons;
Type
    TOptForm = Class(TForm)
        TabbedNotebook1: TTabbedNotebook;
        GroupBox1: TGroupBox;
        CheckBox1: TCheckBox;
        CheckBox2: TCheckBox;
        CheckBox3: TCheckBox;
        CheckBox4: TCheckBox;
        GroupBox2: TGroupBox;
        ListBox1: TListBox;
        GroupBox3: TGroupBox;
        Button2: TButton;
        Button3: TButton;
        GroupBox4: TGroupBox;
        RadioButton1: TRadioButton;
        RadioButton2: TRadioButton;
        RadioButton3: TRadioButton;
        RadioButton4: TRadioButton;
        RadioButton5: TRadioButton;
        Button4: TButton;
        GroupBox5: TGroupBox;
        Button5: TButton;
        Button1: TButton;
        Button6: TButton;
        FontDialog1: TFontDialog;
        ColorDialog1: TColorDialog;
        Procedure Button1Click(Sender: TObject);
        Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
        Procedure FormShow(Sender: TObject);
        Procedure FormCreate(Sender: TObject);
        Procedure ListBox1Click(Sender: TObject);
        Procedure Button6Click(Sender: TObject);
        Procedure Button2Click(Sender: TObject);
        Procedure Button3Click(Sender: TObject);
    End;
Implementation
Uses
    LCalc2;
Var
    EditFont, LogFont: TDamnedFont;
    EditColor, LogColor: TColor;
{$R *.DFM}

Procedure TOptForm.Button1Click(Sender: TObject);
Begin
    With Config Do Begin
        EditAutoSelect:= CheckBox1.Checked;
        ChainCalculation:= CheckBox2.Checked;
        EditAutoFocus:= CheckBox3.Checked;
        AutoSave:= CheckBox4.Checked;
        If RadioButton1.Checked Then CountSystem:= TBin
        Else If RadioButton2.Checked Then CountSystem:= TOct
        Else If RadioButton3.Checked Then CountSystem:= TDec
        Else If RadioButton4.Checked Then CountSystem:= THex
        Else If RadioButton5.Checked Then CountSystem:= TAll;
        EditColor:= LOpt.EditColor;
        ListBoxColor:= LOpt.LogColor;
        Form1.Edit1.Color:= EditColor;
        Form1.ListBox1.Color:= LogColor;
        EditFont:= LOpt.EditFont;
        ListBoxFont:= LOpt.LogFont;
        ApplyFont(LOpt.EditFont, LogFont);
    End;
End;

Procedure TOptForm.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
    Form1.Enable;
    Form1.Refresh;
End;

Procedure TOptForm.FormShow(Sender: TObject);
Begin
    Form1.Disable;
     With Config Do Begin
        CheckBox1.Checked:= EditAutoSelect;
        CheckBox2.Checked:= ChainCalculation;
        CheckBox3.Checked:= EditAutoFocus;
        CheckBox4.Checked:= AutoSave;
        Case CountSystem Of
          TBin:
            RadioButton1.Checked:= True;
          TOct:
            RadioButton2.Checked:= True;
          TDec:
            RadioButton3.Checked:= True;
          THex:
            RadioButton4.Checked:= True;
          TAll:
            RadioButton5.Checked:= True;
        End;
    End;
End;

Procedure TOptForm.FormCreate(Sender: TObject);
Begin
    With ListBox1.Items Do Begin
        Add('  ');
        Add('');
        Add('')
    End;
End;

Procedure TOptForm.ListBox1Click(Sender: TObject);
Begin
    Button2.Enabled:= Not (ListBox1.ItemIndex In [2]);
End;

Procedure TOptForm.Button6Click(Sender: TObject);
Begin
    OptForm.Close;
End;

Procedure TOptForm.Button2Click(Sender: TObject);
Begin
    If FontDialog1.Execute Then Begin
        Case ListBox1.ItemIndex Of
          0:
            Begin
                EditFont.Name:= FontDialog1.Font.Name;
                EditFont.Size:= FontDialog1.Font.Size;
                EditFont.Color:= FontDialog1.Font.Color;
                EditFont.Style:= FontDialog1.Font.Style;
                EditFont.Height:= FontDialog1.Font.Height;
            End;
          1:
            Begin
                LogFont.Name:= FontDialog1.Font.Name;
                LogFont.Size:= FontDialog1.Font.Size;
                LogFont.Color:= FontDialog1.Font.Color;
                LogFont.Style:= FontDialog1.Font.Style;
                LogFont.Height:= FontDialog1.Font.Height;
            End;
        End;
    End;
End;

Procedure TOptForm.Button3Click(Sender: TObject);
Begin
    If ColorDialog1.Execute Then Begin
        Case ListBox1.ItemIndex Of
          0:
            EditColor:= ColorDialog1.Color;
          1:
            LogColor:= ColorDialog1.Color;
        End;
    End;
End;

End.
